package bluesearcher;

import com.hullabaloo.file.copyFile;
import com.hullabaloo.file.openFile;
import com.hullabaloo.file.openFileLoc;
import com.hullabaloo.file.FileInfo;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.ColorUIResource;
import com.hullabaloo.gui.createFileChooser;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.text.ParseException;
import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileSystemView;

/**
 *
 * @author Vincent
 */
public class BlueSearcher {

    public static void main(String[] args) throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException, IOException {
        final JFrame window = new JFrame("Blue SEARCH <no source> ");
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        /*
         SETUP
         */
        JPanel top = new JPanel(new BorderLayout());
        JPanel center = new JPanel();
        GridLayout griddy = new GridLayout(0, 2);
        GridLayout griddy3 = new GridLayout(0, 3);
        center.setLayout(griddy);
        JPanel bottom = new JPanel(new BorderLayout());
        bottom.setLayout(griddy);
        top.setLayout(griddy3);
        final JTextArea dirHolder = new JTextArea(10, 10);
        final JTextArea totalFolder = new JTextArea(10, 10);
        totalFolder.setText("0");
        final JTextField current = new JTextField(55);
        final JTextField current2 = new JTextField(55);
        current.setEditable(false);
        current2.setEditable(false);
        final JTextArea found = new JTextArea(10, 20);
        final DefaultListModel<String> model1 = new DefaultListModel<>();
        final DefaultListModel<String> model2 = new DefaultListModel<>();
        final JList f1 = new JList(model1);
        final JList f2 = new JList(model2);
        final JMenuBar menubar = new JMenuBar();
        final JMenu filter = new JMenu("|                   FILTER                   |");
        menubar.add(filter);
        final JMenuItem clear = new JMenuItem("Clear",new ImageIcon("images/clear.png"));
        final JMenuItem add = new JMenuItem("Add/Remove filters",new ImageIcon("images/plus.png"));
        final JMenuItem search = new JMenuItem("Search files");
        filter.add(add);
      //  filter.add(search);
        filter.add(clear);
        final JMenu info = new JMenu("Info");
        final JScrollPane scroll = new JScrollPane(f1, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        UIManager.put("ScrollBar.trackHighlightForeground", (new Color(51, 153, 255)));
        UIManager.put("scrollbar", (new Color(51, 153, 255)));
        UIManager.put("ScrollBar.thumb", new ColorUIResource(new Color(51, 153, 255)));
        UIManager.put("ScrollBar.thumbHeight", 2);
        UIManager.put("ScrollBar.background", (new Color(243, 239, 224)));
        UIManager.put("ScrollBar.trackForeground", new ColorUIResource(new Color(51, 153, 255)));
        UIManager.put("ScrollBar.foreground", new ColorUIResource(new Color(51, 153, 255)));
        UIManager.put("ScrollBar.shadow", new ColorUIResource(new Color(165, 163, 154)));
        final JTextArea found2 = new JTextArea(10, 20);
        found2.setEditable(false);
        final JScrollPane scroll2 = new JScrollPane(f2, JScrollPane.VERTICAL_SCROLLBAR_NEVER,
                JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        scroll.getVerticalScrollBar().setModel(
                scroll2.getVerticalScrollBar().getModel());
        JButton fileSelect = new JButton("Directory");
        JButton start = new JButton("Start");
        /*
         END SETUP
         */
        add.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    selectFilters sf = new selectFilters();
                } catch (Exception ex) {
                    //
                }
            }
        });
        search.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    int exit = 0;
                    while (exit == 0){
                        String contents = JOptionPane.showInputDialog(null, "Search for files", "Enter a keyword");
                        int foundIndex = model1.indexOf(contents);
                        if(model1.contains(contents)){
                           f1.setSelectedIndex(foundIndex);
                        exit = 1; 
                        }else{
                            JOptionPane.showMessageDialog(null,"Could not find related file");
                        }
                    }
                } catch (Exception ex) {
                    //
                }
            }
        });
        clear.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                model1.removeAllElements();
                model2.removeAllElements();
            }
        });
        fileSelect.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                createFileChooser fc = new createFileChooser("Select a starting location", "DIRECTORIES_ONLY");
                dirHolder.setText(fc.getSelection());
                window.setTitle("Blue SEARCH <" + fc.getSelection() + ">");
            }
        });
        start.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String windowTitle = window.getTitle();
                model1.removeAllElements();
                model2.removeAllElements();
                totalFolder.setText("0");
                try {
                    final ArrayList<String> allFiles = new ArrayList<String>();
                    final ArrayList<String> allFiles_SOURCE = new ArrayList<String>();
                    Path startPath = Paths.get(dirHolder.getText());
                    Files.walkFileTree(startPath, new SimpleFileVisitor<Path>() {
                        @Override
                        public FileVisitResult preVisitDirectory(Path dir,
                                BasicFileAttributes attrs) {
                            int totalVisited = Integer.parseInt(totalFolder.getText());
                            totalVisited += 1;
                            totalFolder.setText(Integer.toString(totalVisited));
                            current.setVisible(true);
                            return FileVisitResult.CONTINUE;
                        }

                        @Override
                        public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws FileNotFoundException {
                            String readF = new Scanner(new File("filter.fl")).useDelimiter("\\A").next();
                            String splitHere = "[,]";
                            int l = 0;
                            String[] tokens = readF.split(splitHere);
                            while (l != tokens.length) {
                                String value = tokens[l];
                                if (file.toString().endsWith(value)) {
                                    String whole = file.toString().replace("\\", "/");
                                    String name = file.getFileName().toString();
                                    if (allFiles.contains(name)) {

                                    } else {
                                        allFiles.add(name);
                                        allFiles_SOURCE.add(whole);
                                        window.setTitle("Found " + allFiles.size() + " files in " + totalFolder.getText() + " folders");
                                    }
                                }
                                l += 1;
                            }
                            return FileVisitResult.CONTINUE;
                        }

                        @Override
                        public FileVisitResult visitFileFailed(Path file, IOException e) {
                            return FileVisitResult.CONTINUE;
                        }
                    });
                    int pos = 0;
                    current.setText("Found " + allFiles.size() + " files in " + totalFolder.getText() + " folders");
                    window.setTitle("BlueSearch <" + dirHolder.getText() + ">");
                    while (pos != allFiles.size()) {
                        int act = pos + 1;
                        File f = new File(allFiles_SOURCE.get(pos));
                        model1.addElement("(" + act + ") " + allFiles.get(pos) + "\n");
                        model2.addElement("(" + act + ") " + allFiles_SOURCE.get(pos) + "\n");
                        pos += 1;
                    }
                } catch (IOException ee) {
                    ee.printStackTrace();
                }
            }
        });
        f1.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent arg0) {
                if (!arg0.getValueIsAdjusting()) {
                    String temp = f1.getSelectedValue().toString();
                    temp = temp.substring(temp.lastIndexOf(")") + 2, temp.length());
                    current2.setText(temp);
                    int s = f1.getSelectedIndex();
                    f2.setSelectedIndex(s);
                    f1.setSelectionForeground(Color.WHITE);
                    f2.setSelectionForeground(Color.WHITE);
                }
            }
        });
        f2.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent arg0) {
                if (!arg0.getValueIsAdjusting()) {
                    int s = f2.getSelectedIndex();
                    String temp = f1.getModel().getElementAt(s).toString();
                    temp = temp.substring(temp.lastIndexOf(")") + 2, temp.length());
                    current2.setText(temp);
                    f1.setSelectedIndex(s);
                }
            }
        });
        f1.setSelectionBackground(new Color(51, 153, 255));
        f2.setSelectionBackground(new Color(51, 153, 255));
        f1.addMouseListener(new MouseAdapter() {
            public void mouseReleased(MouseEvent e) {
                if (SwingUtilities.isRightMouseButton(e)) {
                    String temp = f2.getSelectedValue().toString();
                    temp = temp.substring(temp.lastIndexOf(")") + 2, temp.length());
                    FileInfo file = new FileInfo(new File(temp.trim()));
                    File file2 = new File(temp.trim());
                    Path path = file2.toPath();
                    JPopupMenu popup = new JPopupMenu();
                    popup.add(info);
                    info.removeAll();
                    JMenuItem name = new JMenuItem(file.getName());
                    Icon ico = FileSystemView.getFileSystemView().getSystemIcon(new File(file.getAbsolutePath()));
                    name.setIcon(ico);
                    info.add(name);
                    info.add(new JMenuItem("Absolute path: " + file.getAbsolutePath()));
                    info.add(new JMenuItem("Parent folder " + path.getParent()));
                    info.add(new JMenuItem("Size: " + file.getSize() + " bytes"));
                    info.add(new JMenuItem("Last modified: " + file.getLastModified()));
                    try {
                        if (file.getCreated() != null) {
                            info.add(new JMenuItem("Created: " + file.getCreated()));
                        }
                        if (file.getAccessed() != null) {
                            info.add(new JMenuItem("Accessed: " + file.getAccessed()));
                        }
                        if (file.getWritten() != null) {
                            info.add(new JMenuItem("Written: " + file.getWritten()));
                        }
                        if (file.getOwner() != null) {
                            info.add(new JMenuItem("Owner: " + file.getOwner()));
                        }
                    } catch (IOException ex) {
                        Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (ParseException ex) {
                        Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    info.add(new JMenuItem("FileSystem: " + path.getFileSystem()));
                    info.add(new JMenuItem("is Executable: " + Files.isExecutable(path)));
                    info.add(new JMenuItem("is Readable: " + Files.isReadable(path)));
                    info.add(new JMenuItem("is Writable : " + Files.isWritable(path)));
                    if (Desktop.isDesktopSupported()) {
                        JMenuItem openFileLocation = null;
                        try {
                            openFileLocation = new openFileLoc(f2.getSelectedValue().toString());
                            ImageIcon openFL_icon = new ImageIcon("images/open-sm.png");
                    openFileLocation.setIcon(openFL_icon);
                        } catch (IOException ex) {
                            Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                        }
                        JMenuItem openFile = null;
                        try {
                            openFile = new openFile(f2.getSelectedValue().toString());
                            openFile.setIcon(ico);
                        } catch (IOException ex) {
                            Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                        }
                        popup.add(openFileLocation);
                        popup.add(openFile);
                    }
                    JMenuItem copyPath = null;
                    try {
                        copyPath = new copyFile(f2.getSelectedValue().toString());
                    } catch (IOException ex) {
                        Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    popup.add(copyPath);
                    popup.show(e.getComponent(), e.getX(), e.getY());
                }
            }
        });
        f2.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseReleased(MouseEvent e) {
                if (SwingUtilities.isRightMouseButton(e)) {
                    String temp = f2.getSelectedValue().toString();
                    temp = temp.substring(temp.lastIndexOf(")") + 2, temp.length());
                    FileInfo file = new FileInfo(new File(temp.trim()));
                    File file2 = new File(temp.trim());
                    Path path = file2.toPath();
                    JPopupMenu popup = new JPopupMenu();
                    popup.add(info);
                    info.removeAll();
                    JMenuItem name = new JMenuItem(file.getName());
                    Icon ico = FileSystemView.getFileSystemView().getSystemIcon(new File(file.getAbsolutePath()));
                    name.setIcon(ico);
                    info.add(name);
                    info.add(new JMenuItem("Absolute path: " + file.getAbsolutePath()));
                    info.add(new JMenuItem("Parent folder " + path.getParent()));
                    info.add(new JMenuItem("Size: " + file.getSize() + " bytes"));
                    info.add(new JMenuItem("Last modified: " + file.getLastModified()));
                    try {
                        if (file.getCreated() != null) {
                            info.add(new JMenuItem("Created: " + file.getCreated()));
                        }
                        if (file.getAccessed() != null) {
                            info.add(new JMenuItem("Accessed: " + file.getAccessed()));
                        }
                        if (file.getWritten() != null) {
                            info.add(new JMenuItem("Written: " + file.getWritten()));
                        }
                        if (file.getOwner() != null) {
                            info.add(new JMenuItem("Owner: " + file.getOwner()));
                        }
                    } catch (IOException ex) {
                        Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (ParseException ex) {
                        Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    info.add(new JMenuItem("FileSystem: " + path.getFileSystem()));
                    info.add(new JMenuItem("is Executable: " + Files.isExecutable(path)));
                    info.add(new JMenuItem("is Readable: " + Files.isReadable(path)));
                    info.add(new JMenuItem("is Writable : " + Files.isWritable(path)));
                    if (Desktop.isDesktopSupported()) {
                        JMenuItem openFileLocation = null;
                        try {
                            openFileLocation = new openFileLoc(f2.getSelectedValue().toString());
                            ImageIcon openFL_icon = new ImageIcon("images/open-sm.png");
                    openFileLocation.setIcon(openFL_icon);
                        } catch (IOException ex) {
                            Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                        }
                        JMenuItem openFile = null;
                        try {
                            openFile = new openFile(f2.getSelectedValue().toString());
                            openFile.setIcon(ico);
                        } catch (IOException ex) {
                            Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                        }
                        popup.add(openFileLocation);
                        popup.add(openFile);
                    }
                    JMenuItem copyPath = null;
                    try {
                        copyPath = new copyFile(f2.getSelectedValue().toString());
                    } catch (IOException ex) {
                        Logger.getLogger(BlueSearcher.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    popup.add(copyPath);
                    popup.show(e.getComponent(), e.getX(), e.getY());
                }
            }
        });
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        window.setIconImage(Toolkit.getDefaultToolkit().getImage("images/open.png"));
        
        window.add(BorderLayout.NORTH, top);
        window.add(BorderLayout.SOUTH, bottom);
        top.add(menubar);
        top.add(fileSelect);
        top.add(start);
        bottom.add(current);
        bottom.add(current2);
        window.add(BorderLayout.CENTER, center);
        center.add(scroll);
        center.add(scroll2);
        window.setSize(500, 500);
        window.setMinimumSize(new Dimension(500, 500));
        window.setVisible(true);
        window.setLocationRelativeTo(null);
    }

}
