package bluesearcher;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author Baxter
 */
public class selectFilters {

    public selectFilters() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException, FileNotFoundException {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        /*CREATE COMPONENTS*/
        final JFrame window = new JFrame();
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        window.setTitle("Select filters");
        final JButton save = new JButton("Save changes",new ImageIcon("images/save.png"));
        final JButton exit = new JButton("Close",new ImageIcon("images/exit.png"));
        JTextArea topText = new JTextArea();
        JPanel topPanel = new JPanel();
        JPanel centerPanel = new JPanel();
        JPanel bottomPanel = new JPanel();
        final JCheckBox png = new JCheckBox(".png");
        final JCheckBox jpg = new JCheckBox(".jpg");
        final JCheckBox bmp = new JCheckBox(".bmp");
        final JCheckBox txt = new JCheckBox(".txt");
        final JCheckBox pdf = new JCheckBox(".pdf");
        final JCheckBox rtf = new JCheckBox(".rtf");
        String readF = new Scanner(new File("filter.fl")).useDelimiter("\\A").next();
        String splitHere = "[,]";
        int l = 0;
        String[] tokens = readF.split(splitHere);
        setFilters.filters.clear();
        while (l < tokens.length) {
            String value = tokens[l];
            if (value.equals(".png")) {
                png.doClick();
                setFilters.filters.add(".png,");
                l += 1;
            }
            if (value.equals(".jpg")) {
                jpg.doClick();
                setFilters.filters.add(".jpg,");
                l += 1;
            }
            if (value.equals(".bmp")) {
                bmp.doClick();
                setFilters.filters.add(".bmp,");
                l += 1;
            }
            if (value.equals(".txt")) {
                txt.doClick();
                setFilters.filters.add(".txt,");
                l += 1;
            }
            if (value.equals(".rtf")) {
                rtf.doClick();
                setFilters.filters.add(".rtf,");
                l += 1;
            }
            if (value.equals(".pdf")) {
                pdf.doClick();
                setFilters.filters.add(".pdf,");
                l += 1;
            }
        }
        topPanel.setBackground(new Color(51, 153, 255));
        bottomPanel.setBackground(new Color(51, 153, 255));
        exit.setBorderPainted(false);
        exit.setBackground(new Color(51, 153, 255));
        save.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int currentIndex = 0;
                int stop = 0;
                String allFilters = null;
                while (stop != 1) {
                    try {
                        allFilters += setFilters.filters.get(currentIndex);
                        currentIndex += 1;
                    } catch (IndexOutOfBoundsException st) {
                        stop = 1;
                    }
                }
                try {
                    allFilters = allFilters.substring(4).trim();
                    allFilters = allFilters.substring(0, allFilters.length() - 1);
                    PrintWriter writer = new PrintWriter("filter.fl");
                    writer.print("");
                    writer.close();
                    FileWriter reopen = new FileWriter("filter.fl", true);
                    BufferedWriter newopen = new BufferedWriter(reopen);
                    newopen.write(allFilters.trim());
                    newopen.close();
                    window.dispose();
                } catch (IOException ex) {
                    Logger.getLogger(selectFilters.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
        exit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                window.dispose();
            }
        });
        png.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setFilters sf = new setFilters("png", png);
            }
        });
        jpg.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setFilters sf = new setFilters("jpg", jpg);
            }
        });
        bmp.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setFilters sf = new setFilters("bmp", bmp);
            }
        });
        txt.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setFilters sf = new setFilters("txt", txt);
            }
        });
        rtf.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setFilters sf = new setFilters("rtf", rtf);
            }
        });
        pdf.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setFilters sf = new setFilters("pdf", pdf);
            }
        });
        /*EDIT COMPONENT SETTINGS*/
        topText.setText("Select Filters");
        topText.setEditable(false);
        topText.setBackground(new Color(51, 153, 255));
        topText.setForeground(Color.WHITE);
        GridLayout griddy = new GridLayout(0, 3);
        centerPanel.setLayout(griddy);
        topPanel.add(topText);
        bottomPanel.add(save);
        bottomPanel.add(exit);
        centerPanel.add(png);
        centerPanel.add(jpg);
        centerPanel.add(bmp);
        centerPanel.add(txt);
        centerPanel.add(pdf);
        centerPanel.add(rtf);
        /*EDIT WINDOW SETTINGS*/
        window.add(BorderLayout.NORTH, topPanel);
        window.add(BorderLayout.CENTER, centerPanel);
        window.add(BorderLayout.SOUTH, bottomPanel);
        window.setSize(450, 150);
        window.setUndecorated(true);
        window.setLocationRelativeTo(null);
        window.setResizable(true);
        window.setVisible(true);
    }
}
